
/*
 ******************************************
 **	    by Widgetschmie.de 2005-2008	 **
 ******************************************
 */


var possLangs = new Array('de', 'en');


// opens a webpage
function gotoURL(url) {
	if(window.widget) {
		widget.openURL(url);
	}
}

function gotoWebsite() {
	gotoURL("http://www.widgetschmie.de/widgets/Fernsehen/");
}


// returns the object, whether you supply an id (string) or an object itself
function getObj(id) {
	var obj;
	if(typeof(id) == "string") {
		obj = getById(id) ? getById(id) : null;
	}
	else if(typeof(id) == "object") {
		obj = id;
	}
	
	return obj;
}

// returns the object with the correspondent ID
function getById(id) {
	if(document.getElementById)
		return document.getElementById(id);
	else if(document.all)
		return document.all[id];
	else
		return false;
}

// returns the first child node with a certain name from a tree
function getChildNodeNamed(someTree, nodeName)
{
	if (someTree.tagName == nodeName) return someTree;
	if (!someTree.hasChildNodes()) return null;
	var children = someTree.childNodes;
	for (var i = 0; i < children.length; i++)
	{
		var result = getChildNodeNamed(children[i], nodeName);
		if (result != null) return result;
	}
	return null;
}


// returns the child-nodes of an element (stripping all #text and #comment - nodes)
function getElementNodes(obj) {
	var elem = new Array();
	if(!obj || !obj.childNodes)
		return elem;
	
	var childs = obj.childNodes;
	for(var i = 0; i < childs.length; i++) {
		if("#text" != childs[i].nodeName.toLowerCase() && "#comment" != childs[i].nodeName.toLowerCase())
			elem.push(childs[i]);
	}
	return elem;
}


// cleans a node from its childs
function cleanNode(node) {
	if(typeof(node) != "object") {
		node = getObj(node);
		if(typeof(node) != "object")
			return false;
	}
	
	while(node.firstChild != null) {
		node.removeChild(node.firstChild);
	}
}


// returns the localized String
function locStr(key) {
	try {
		var ret = localizedStrings[key];
		return (undefined === ret) ? key : ret;
	}
	catch (ex) {  }
	
	return key;
}


// returns a formatted date/time from a timestamp
function formatTime(stamp) {
	if('object' != typeof(stamp)) {
		var date = new Date();
		date.setTime(stamp);
	}
	else {
		date = stamp;
	}
	
	var hour = date.getHours();
	var minute = date.getMinutes();
	var dateString = ((hour >= 10) ? hour : "0"+hour) + "." + ((minute >= 10) ? minute : "0"+minute);
	return dateString;
}

function formatDate(stamp) {
	if('object' != typeof(stamp)) {
		var date = new Date();
		date.setTime(stamp);
	}
	else {
		date = stamp;
	}
	
	var dat = date.getDate() + "." + (date.getMonth() + 1) + ".";
	return dat;
}

function dayAndDate(stamp) {
	if('object' != typeof(stamp)) {
		var date = new Date();
		date.setTime(stamp);
	}
	else {
		date = stamp;
	}
	
	var day = localizedWeekday(date);
	var date = formatDate(date);
	
	return day + ' ' + date;
}

// returns the difference between two timestamps regarding their dates. 0 = same day, 1 = second date is one day after first date, ...
function dateDifference(firstStamp, secondStamp) {
	firstStamp.setHours(secondStamp.getHours());
	firstStamp.setMinutes(secondStamp.getMinutes());
	firstStamp.setSeconds(secondStamp.getSeconds());
	
	var dayOffset = Math.round((secondStamp.getTime() - firstStamp.getTime()) / 86400000);
	return dayOffset;
}

function localizedWeekday(date)
{
	var weekday = date.getDay();
	if(6 == weekday && 'DE' == LOCALE)			// Spezial "Sonnabend" :-)
		return locStr("day_6_DE");
	
	return locStr("day_" + weekday);
}

function printableDate(date)			// should not be used anymore
{
	return dayAndDate(date);
}

// formats minutes as hour:minutes
function minutesAsString(minutes)
{
	var result = Math.floor(minutes / 60) + ":";
	var remMins = (minutes % 60);
				
	if (remMins < 10) result += "0" + remMins
	else result += remMins;
	
	return result;
}


// marks the given searchstrings in the given string (No longer used in 2.0... but it's so nice let's keep it. We love it. :))
function markSearchString(string, searchstrings) {
	if(!string)
		return;
	
	if(searchstrings && searchstrings.length) {
		for(var i = 0; i < searchstrings.length; i++) {
			var str = encodeRE(searchstrings[i]);
			var reg = new RegExp('(' + str + ')', 'gi');
			string = string.replace(reg, "#$1#");
		}
		
		// now, really mark
		string = string.replace(/#([^#]+)#/g, '<span class="searchResult">$1</span>');
	}
	
	return string;
}

// masks potential RegExp chars
function encodeRE(s) {
	return s.replace(/([.*+?^${}()|[\]\/\\])/g, '\\$1');
}


// returns the property the browser calculated, if that`s not supported, from the style.
function getComputedValue(prop, obj) {
	var myObj = getObj(obj);
	if(myObj) {
		var getit;
		if(document.defaultView.getComputedStyle) {
			getit = document.defaultView.getComputedStyle(myObj, null).getPropertyValue(prop);
		}
		else {
			getit = myObj.style[prop];
		}
		
		return getit;
	}
}

// returns the absolute starting point of the left upper edge of an element (relative to the window)
function getAbsoluteCoordinates(element) {
	var x = 0;
	var y = 0;
	
	if(element) {
		var i = 0;
		
		while(null != element.parentNode) {
			if(i++ > 1000) {
				break;				// our seatbelt
			}
			
			x += (element.offsetLeft - (element.parentNode && element.parentNode.scrollLeft ? element.parentNode.scrollLeft : 0));
			y += (element.offsetTop - (element.parentNode && element.parentNode.scrollTop ? element.parentNode.scrollTop : 0));
			
			element = element.parentNode;
		}
	}
	
	return x + ":" + y;
}


function parseChannelName(channel) {
	var channelname = channel;
	if(channelname)
		channelname = channelname.replace(/\+/g, " ");
	
	return channelname;
}


// does not return anything but works on the original array!
function removeValueFromArray(value, array) {
	if(array && array.length) {
		for(var i = array.length; i > 0; i--) {
			if(value == array[i-1]) {
				array.splice(i-1, 1);
			}
		}
	}
}

function removeKeyFromHash(removeKey, array)
{
	var result = new Object();
	for (var key in array)
	{
		if (key != removeKey) result[key] = array[key];
	}
	return result;
}

function keysFromHash(hash)
{
	var keys = new Array();
	for (var key in hash)
	{
		keys.push(key);
	}
	return keys;
}

function indexOfObjectInArray(array, object)
{
	if("object" != typeof(array)) return -1;
	for (i = 0; i < array.length; i++)
	{
		if (array[i] == object) return i;
	}
	return -1;
}

function indexOfValueInArray(array, value)
{
	if(array && array.length) {
		for(i = 0; i < array.length; i++) {
			if (array[i] == value) return i;
		}
	}
	return -1;
}

function array_unique(array) {
	var newArr = new Array();
	if(array && array.length) {
		for(i = 0; i < array.length; i++) {
			if(!inArray(array[i], newArr)) {
				newArr.push(array[i]);
			}
		}
	}
	
	return newArr;
}

function inArray(value, arr)
{
	if("object" != typeof(arr)) return false;
	
	for(var i = 0; i < arr.length; i++)
	{
		if(arr[i] == value) return true;
	}
	return false;
}


// selects the preceding input element. Use it for span-objects describing the purpose of a checkbox
function selectVal(clicked) {
	var elem = getObj(clicked);
	while(null != elem.previousSibling) {
		if('input' == elem.previousSibling.nodeName.toLowerCase()) {
			if(! elem.previousSibling.disabled) {
				elem.previousSibling.checked = ! elem.previousSibling.checked;
				return true;
			}
			return false;
		}
		elem = elem.previousSibling;
	}
	
	return false;
}

// unchecks an input-element if another gets checked
function uncheckIfChecked(elements, reference) {
	var uncheck = (getObj(reference) && (true == getObj(reference).checked));
	if(!uncheck)
		return;
	
	var all_elems = new Array();
	if('string' == typeof(elements))
		all_elems.push(elements);
	else
		all_elems = elements;
	
	for(var i = 0; i < all_elems.length; i++) {
		var elem = getObj(all_elems[i]);
		
		if(elem) {
			elem.checked = false;
		}
	}
}


function selectValue(element, value)
{
	if(!element) return;
	
	for (i = 0; i < element.length; i++)
	{
		if (element.options[i].value == value)
		{
			element.selectedIndex = i;
			return;
		}
	}
}

function openDiagnosis()
{
	blendDialogOut();
	if(window.widget) widget.openApplication("com.apple.NetworkDiagnostics");
}

function openConsole()
{
	if(window.widget) widget.openApplication("com.apple.Console");
}

function currentLocale()
{
	if(!window.widget)
		return "DE";
	
	var locale = FernsehPlugin.currentLocale();
	if (undefined == locale) return "DE";
	
	locale = (locale.indexOf('@') > -1) ? locale.substr(0, locale.indexOf('@')) : locale;
	var comps = locale.split("_");
	if (comps.length != 2) return "DE";
	return comps[1];
}

function systemLang() {
	var langs = FernsehPlugin.appleLanguages().split(",");
	for (var i = 0; i < langs.length; i++)
	{
		if (inArray(langs[i], possLangs)) return langs[i];
	}
	// no valid language found
	return "en";
}

function mergeHashes(hashOne, hashTwo)
{
	var result = new Object();
	for (var key in hashOne)
	{
		result[key] = hashOne[key];
	}
	for (var key in hashTwo)
	{
		result[key] = hashTwo[key];
	}
	return result;
}

function mergeArrays(one, two) {
	var result = new Array();
	for(var i = 0; i < one.length; i++) {
		result.push(one[i]);
	}
	for(var i = 0; i < two.length; i++) {
		result.push(two[i]);
	}
	return result;
}

function deunicodifyLatinUmlauts(string)
{
	var result = escape (string);
	result = result.replace(/a%u0308/g, "\u00E4"); // ae
	result = result.replace(/A%u0308/g, "\u00C4"); // ae
	result = result.replace(/o%u0308/g, "\u00F6"); // oe
	result = result.replace(/O%u0308/g, "\u00D6"); // oe
	result = result.replace(/u%u0308/g, "\u00FC"); // ue
	result = result.replace(/U%u0308/g, "\u00DC"); // ue
	result = result.replace(/e%u0301/g, "\u00E9"); // e aigu
	result = result.replace(/a%u0301/g, "\u00E1"); // a aigu
	result = result.replace(/o%u0301/g, "\u00F3"); // o aigu
	result = result.replace(/e%u0300/g, "\u00E8"); // e grave
	result = result.replace(/a%u0300/g, "\u00E0"); // a grave
	result = result.replace(/o%u0300/g, "\u00F2"); // o grave
	result = unescape(result);
	return result;
}

function unicodifyLatinUmlauts(string)
{
	var result = escape (string);
	result = result.replace(/%E4/g, "a%u0308"); // ae
	result = result.replace(/%C4/g, "A%u0308"); // ae
	result = result.replace(/%F6/g, "o%u0308"); // oe
	result = result.replace(/%D6/g, "O%u0308"); // oe
	result = result.replace(/%FC/g, "u%u0308"); // ue
	result = result.replace(/%DC/g, "U%u0308"); // ue
	result = result.replace(/%E9/g, "e%u0301"); // e aigu
	result = result.replace(/%E1/g, "a%u0301"); // e aigu
	result = result.replace(/%F3/g, "o%u0301"); // o aigu
	result = result.replace(/%E8/g, "e%u0300"); // e grave
	result = result.replace(/%E0/g, "a%u0300"); // e grave
	result = result.replace(/%F2/g, "o%u0300"); // o grave
	result = unescape(result);
	return result;
}

// returns a SHALLOW copy of a hash
// not appropriate for DEEP copies!
function copyHash(hash)
{
	var result = new Object();
	for (var key in hash)
	{
		result[key] = hash[key];
	}
	return result;
}

function copyArray(array)
{
	var result = new Array();
	for (var i = 0; i < array.length; i++)
	{
		result.push(array[i]);
	}
	return result;
}

function debug(string)
{
	if (!debugMode) return;
	alert(string);
}


function has1043Features() {
	var version = navigator.appVersion;
	var regExp = /.+AppleWebKit\/([\d\.]+).+/;
	var result = regExp.exec(version);
	
	return (parseFloat(result[1]) >= 416.11);
}




// JS serialization

function Serialize(obj) {
	var strSource = "";

	if (typeof(obj) == "undefined") {
		strSource = "undefined";
	}

	else if (obj == null) {
		strSource = "null";
	}

	else if (typeof(obj) == "boolean" || typeof(obj) == "number" || typeof(obj) == "function") {
		strSource = obj;
	}

	else if (typeof(obj) == "string") {
		strSource = "'" + obj.replace(/([\\'"])/g, "\\$1") + "'"; 		//" (just to avoid the texteditors problems with the single Notation Mark)
	}

	else if (typeof(obj) == "object") {
		if (obj.constructor == Boolean) {
			strSource = "new Boolean(" + obj.valueOf() + ")";
		}

		else if (obj.constructor == Number) {
			strSource = "new Number(" + obj.valueOf() + ")";
		}

		else if (obj.constructor == String) {
			strSource = "new String(" + Serialize(obj.toString()) + ")";
		}

		else if (obj.constructor == Date) {
			strSource = "new Date(" + obj.valueOf() + ")";
		}

		else if (obj.constructor == Array) {
			strSource = "[";
			for (var i=0; i<obj.length; i++)
				strSource += Serialize(obj[i]) + ",";
			if (i>0)
				strSource = strSource.substring(0, strSource.length-1);
			strSource += "]";
		}

		else if (obj.constructor == RegExp) {
			strSource = obj.toString();
		}

		else if (obj.constructor == Object) {
			var strSource = "{"
			for (var key in obj)
				strSource = strSource + "" + key + ":" + Serialize(obj[key]) + ","
			if (strSource.length > 1)
				strSource = strSource.substring(0, strSource.length-1);
			strSource += "}";
		}
	}

	else {
		throw new Error(0, "Serialize encountered unexpected object type: " + typeof(obj));
	}

	return strSource;
}


function Deserialize(strSource) {
	if (typeof strSource != "string")
		throw new Error(0, "Deserialize expects a string argument");

	var x;
	try {
		return eval("x = " + strSource);
	}
	catch(exc) {
		alert("Deserialize: " + exc);
	}
}

